<!doctype html>
<html lang="en">

<head>

<meta charset="UTF-8">
<title>Automatic Feeding Station</title>
	
<style type="text/css">

body.mainBody
{
	color: #000000;
	background-color: #FFFFFF;
	width: 85%;
	text-align: left;
	margin-left: auto;
	margin-right: auto;
	margin-bottom: 25px;
	font-size: 100%;
}

div.container
{
	overflow: auto;
	width: 100%;
	height: 100%;
}

@media (min-width:861px)
{
	.box
	{
		box-sizing: border-box;
		float: left;
		width: 50%;
		height: 100%;
	}
}

@media (max-width:860px)
{
	.box
	{
		box-sizing: border-box;
		float: left;
		width: 100%;
		height: 100%;
	}
}

input[type=submit]
{
    width: 20em;
	height: 2em;
}

input[type=text]
{
    width: 20em;
}

input[type=password]
{
    width: 20em;
}

input[type=number]
{
    width: 20em;
}

</style>

</head>


<body class="mainBody">

<center><h1>Raspberry Pi Feeding Station</h1></center>

<hr>

<?php
/////////////////////////// Handle logging in for admin functions //////////////////////////////////
session_start();
if ($_SESSION['login']==true || ($_POST['user']=="sput" && $_POST['pass']=="catzrule")) {
	//If they already have a session, give them access.
	//If not, check for posted UN & PW and if correct, give access.
	$_SESSION['login']=true; //Set login to true in case they got in via UN & PW
	//Remove login form, and show admin stuff
	
	$useronline = true;
	
}else {
	//Not already logged in, not sent a password. Display login form, and no admin stuff.
	
	$useronline = false;
}

$jobs_list = $_SESSION['jobs_list'];

///////////////////////////// Different content for users and admin ////////////////////////////////

if ($useronline){ ?>

<h2>Admin functions:</h2>
<form action="form_process.php" method="POST">
	<input type="submit" name="feedportion" value="Feed Portion" width="60px"/><br>
	<br>
	<input type="submit" name="takesnapshot" value="Take snapshot" /><br>
	Picture takes some time to load. Reload this page again after a few seconds if taking a snapshot.<br>
	<br>
	<input type="submit" name="setrtctime" value="Set RTC time to system time" /><br>
	<br>
	<input type="submit" name="deleteimages" value="Delete All images" />
	<br>
	<!--<h4>New Feeding Interval [hours]:</h4>
	<input type="number" name="newFeedingInterval" min="1" max="12"/><br>-->
	<h4>Portions per day:</h4>
	 <select name="newFeedingInterval">
		<option value="2">2</option>
		<option value="3">3</option>
		<option value="4">4</option>
		<option value="6">6</option>
		<option value="8">8</option>
		<option value="12">12</option>
		<option value="24">24</option>
	</select> 
	
	<input type="submit" name="newInterval" value="Update" /><br>
	
	
	<br>
	<input type="submit" name="printCrontabList" value="View feeding schedule" /><br>
	<br>
	<input type="submit" name="stopTimedFeeding" value="Stop Timed Feeding" /><br>
	<br>
	<input type="submit" name="stopTimedFeeding" value="Stop Motion Capture" />
	<br>
	Motion capturing can be started again by taking a snapshot.<br>
	<br>
	<input type="submit" name="shutdownSystem" value="Shutdown System" />
</form>

<?php } else { ?>

<h3>Admin Login:</h3>
<form action="form_process.php" method="POST">
	Username:<br>
	<input type="text" name="user" /><br>
	Password:<br>
	<input type="password" name="pass" /><br>
	<br>
	<input type="submit" value="Log in" />
</form>

<?php } ?>

<!---------------------- Static content for both admin and users ----------------------------->

<br>
<hr>
<h2>Feeding Station Status</h2>

<div class="container">

<?php
////////////////////////////////// Execute scripts //////////////////////////////////////////////////

$core_temperature = shell_exec('/opt/vc/bin/vcgencmd measure_temp');
$int_temperature = shell_exec('python read_temp.py');
$ext_temperature = shell_exec('python read_external_temp.py');
$ir_beam_state = shell_exec('python read_feed_level.py');
exec('python read_time.py', $servo_board_time);
exec('python internet_time.py', $internet_time);

// Read power up/down time stamps from text file
$time_stamps_filename = "time_stamp.txt";

if (file_exists($time_stamps_filename)) {
	$stamps_file = fopen($time_stamps_filename, "r") or die("Unable to open time-stamps file!");

	$stamps = "";
	while(!feof($stamps_file)) {
		$stamps = $stamps . fgets($stamps_file) . "<br>";
	}

	fclose($stamps_file);
	
} else {
	$stamps = "Not found";
}


// Read last feeding time from text file
$feed_stamps_filename = "feed_stamps.txt";

if (file_exists($feed_stamps_filename)) {
	$feed_stamps_file = fopen($feed_stamps_filename, "r") or die("Unable to open feed-stamps file!");

	$stamps_feed = "";
	while(!feof($feed_stamps_file)) {
		$stamps_feed = $stamps_feed . fgets($feed_stamps_file) . "<br>";
	}

	fclose($feed_stamps_file);
	
} else {
	$stamps_feed = "Not found";
}



// Read feeding interval from text file
$feed_interval_filename = "feed_freq.txt";

if (file_exists($feed_interval_filename)) {
	$feed_interval_file = fopen($feed_interval_filename, "r") or die("Unable to open feed-stamps file!");

	$interval_feed = "";
	while(!feof($feed_interval_file)) {
		$interval_feed = $interval_feed . fgets($feed_interval_file) . "<br>";
	}

	fclose($feed_interval_file);
	
} else {
	$interval_feed = "Not found";
}

////////////////////////////////// Print the results //////////////////////////////////////////////////
print <<<HTML
	<div class="box">
		<h3>Temperature Sensors:</h3>
		<p>$ext_temperature</p>
		<p>$int_temperature</p>
		<p>Processor $core_temperature</p>
		
		<br>
		
		<h3>Feeding info:</h3>
		<p>$interval_feed</p>
		<p>$stamps_feed</p>
		<p>$jobs_list</p>
		
		<br>
		
		<h3>Feed level:</h3>
		<p>$ir_beam_state</p>
	</div>

	<div class="box">
		<h3><p>$internet_time[0]</p></h3>
		<p>$internet_time[1]</p>
		<p>$internet_time[2]</p>
		
		<h3><p>$servo_board_time[0]</p></h3>
		<p>$servo_board_time[1]</p>
		<p>$servo_board_time[2]</p>
		
		<br>
		
		<h3>Time Stamps, RTC:</h3>
		<p>$stamps</p>
	</div>
HTML;
?>
	
</div>

<hr>

<h3>Captured Images</h3>

<?php
	// Grab images from web cam, which are placed in a folder

	$dirname = "camera/";
	$images_in_folder = glob($dirname."*.jpg");
	if (count($images_in_folder) > 0)
	{
		$sorted_newest_first_image_list = array_reverse($images_in_folder);
		/*foreach($sorted_newest_first_image_list as $image)
		{
			echo '<img src="'.$image.'" style="width:600px;height:440px;"/><br />';
		}*/
		
		// Only show the newest image
		echo '<img src="'.reset($sorted_newest_first_image_list).'" style="width:600px;height:440px;"/><br />';
		
		if (count($images_in_folder) > 1)
		{
			echo '<a href="all_images.php"><h3>See all images<h3></a>';
		}
	}
	else
	{
		// Nothing to show
		echo 'No images captured yet!';
	}
?>

</body>
</html>