# import the necessary packages
from picamera.array import PiRGBArray
from picamera import PiCamera
import time
import cv2
import imutils
import datetime

# Define constants
camera_warmup_time = 1.5
resolution = [1280, 860]

# initialize the camera and grab a reference to the raw camera capture
camera = PiCamera()
camera.resolution = tuple(resolution)
rawCapture = PiRGBArray(camera, size=tuple(resolution))

print "[INFO] taking image still"

time.sleep(camera_warmup_time)

# grab an image from the camera
camera.capture(rawCapture, format="bgr")
rawImage = rawCapture.array

# the timestamp and occupied/unoccupied text
timestamp = datetime.datetime.now()

# draw the text and timestamp on the frame
image = imutils.rotate(rawImage, angle=180)
ts = timestamp.strftime("%A %d %B %Y %H:%M:%S")
timeStampFilename = timestamp.strftime("%Y_%m_%d_%H%M%S")
fontSize = 1.2
fontThickness = 2
cv2.putText(image, ts, (10, image.shape[0] - 10), cv2.FONT_HERSHEY_SIMPLEX,
	fontSize, (0, 255, 0), fontThickness)

# write the image to file
filePath = "/var/www/camera/{fileName}.jpg".format(fileName=timeStampFilename)
cv2.imwrite(filePath, image)

print "[INFO] picture taken"