import smbus
import time

bus = smbus.SMBus(1) #Depends on which I2C bus is in use

DEVICE_ADDRESS = 0x3E #Configured ATmega328P I2C address

############IO board register locations#######################
TEMP_LOWER_BYTE = 0x04
TEMP_UPPER_BYTE = 0x05

#################Temperature##################################

# Read temperature from DS18B20 sensor

# Request a temperature sensor refresh. 11-bit resolution, so takes 375ms.
temperature = bus.write_byte_data(DEVICE_ADDRESS, TEMP_LOWER_BYTE, 1)
time.sleep(0.5)

# Data should be ready, read it!
upper = bus.read_byte_data(DEVICE_ADDRESS, TEMP_UPPER_BYTE)
lower = bus.read_byte_data(DEVICE_ADDRESS, TEMP_LOWER_BYTE)

# Set bytes together to a word
temperature_bytes = (upper << 8) | lower

# Parse it. The temperature data is stored in a 16-bit sign-extended 2:s complement form in the temperature register.
# so the number needs to be "inverted" when reading negative temperatures. The sign bit is the MSB bit.

# Mask bits, and check polarity
polarity = (temperature_bytes & (1 << 15))

if polarity:
	# Negative temp, so convert from 2's complement
	temperature_bytes = ~temperature_bytes
	temperature_bytes = temperature_bytes + 1

	# Scale, and add negative sign
	temperature_real = temperature_bytes * 0.0625
	temperature_real = temperature_real * -1.0
	
else:
	# Positive temp, so just scale it
	temperature_real = temperature_bytes * 0.0625


print "Ambient Temperature: %.4fC" % (temperature_real)
