import smbus

bus = smbus.SMBus(1) #Depends on which I2C bus is in use

DEVICE_ADDRESS = 0x18 #Configured MCP9808 I2C address

############MCP9808 register locations#######################
DEVICE_CONFIG_REG = 1
DEVICE_ALERT_UPPER_REG = 2
DEVICE_ALERT_LOWER_REG = 3
DEVICE_CRITICAL_TEMP_REG = 4
DEVICE_TEMP_REG = 5
DEVICE_MANUFACTURER_ID_REG = 6
DEVICE_ID_REG = 7
DEVICE_RESOLUTION_REG = 8

#################Temperature##################################
temperature = bus.read_word_data(DEVICE_ADDRESS, DEVICE_TEMP_REG)
# Reverse bytes
lower = (temperature >> 8)
upper = (temperature & 0xFF)
# Mask alert bits, and check polarity
polarity = (upper & 0b00010000)
upper = (upper & 0x0F)
#Convert to celcius
temperature = (lower | (upper << 8))
temp_real = temperature * 0.0625
# Set correct polarity
if polarity:
	temp_dec = temp_dec * -1.0

# Display the results
print "Internal Temperature: %.4fC" % (temp_real)
